unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  ExtCtrls;
// STDControls wegen TLabel ergänzen

  type
  TMinenButton = class(TLabel)
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    wert: integer;
    markiert: boolean;
    constructor create(AOwner: TComponent);  override;
    procedure mouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
  end;


type

  { TForm1 }

  TForm1 = class(TForm)
    Timer1: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure aufdecken(i, j: integer);
    procedure Timer1Timer(Sender: TObject);
    public

    button: array[0..14,0..14] of TMinenButton;
  end;




var
  Form1: TForm1;
  minenZahl: integer = 20;
  markieren: boolean;

implementation

{$R *.lfm}

constructor TMinenButton.create(AOwner: TComponent);
begin
  inherited create(AOwner);
  self.Font.Style := [fsbold];
  self.Font.Name := 'Tahoma';
  self.AutoSize := false;
  self.Alignment := taCenter;
  self.color := clltgray;
  self.layout := tlcenter;
  self.height := 25;
  self.width := 25;
  self.wert := 0;
  self.markiert := false;
end;

procedure TMinenButton.mouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if button = mbRight then
  begin
    markiert := true;
    if color <> clgreen then
      color := clgreen
    else
      color := clltgray;
  end
  else
  begin
    if wert > 0 then
      caption := inttostr(wert);
    color := clwhite;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
var i, j: integer;
x, y: integer;
begin
  // Felder setzen
  for i:=0 to 14 do
    for j:=0 to 14 do
    begin
      button[i,j]:=TMinenButton.create(self);
      button[i,j].parent := self;
      button[i,j].top := 10+26*i;
      button[i,j].left := 10+26*j;
    end;

  // Minen legen
  randomize;
  for i:=1 to minenZahl do
  begin
     x := random (15);
     y := random (15);
     button[x,y].wert := -1;
  end;

  // Felder berechnen
  for i:=0 to 14 do
    for j:=0 to 14 do
    begin
      if button[i,j].wert <> -1 then
      begin
        if (i>0) and (j>0) then
          if button[i-1,j-1].wert = -1 then inc(button[i,j].wert);
        if i>0 then
          if button[i-1,j].wert = -1 then inc(button[i,j].wert);
        if (i>0) and (j<14) then
          if button[i-1,j+1].wert = -1 then inc(button[i,j].wert);
        if j>0 then
          if button[i,j-1].wert = -1 then inc(button[i,j].wert);
        if j<14 then
          if button[i,j+1].wert = -1 then inc(button[i,j].wert);
        if (i<14) and (j>0) then
          if button[i+1,j-1].wert = -1 then inc(button[i,j].wert);
        if i<14 then
          if button[i+1,j].wert = -1 then inc(button[i,j].wert);
        if (i<14) and (j<14) then
          if button[i+1,j+1].wert = -1 then inc(button[i,j].wert);
      end;
    end;
end;

procedure TForm1.aufdecken(i, j: integer);
begin
  if button[i,j].wert > 0 then
    button[i,j].Caption := inttostr(button[i,j].wert);
  if button[i,j].wert = -1 then
    button[i,j].Caption := 'X';
  if button[i,j].wert <> -1 then
    button[i,j].Color := clwhite
  else
    button[i,j].Font.Color := clred;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var i, j: integer;
  verloren: boolean;
begin
  for i := 0 to 14 do
    for j := 0 to 14 do
      if (button[i,j].color = clwhite) and (button[i,j].wert = 0) then
      begin
        if (i>0) and (j>0) then aufdecken(i-1,j-1);
        if i>0 then aufdecken(i-1,j);
        if (i>0) and (j<14) then aufdecken(i-1,j+1);
        if j>0 then aufdecken(i,j-1);
        if j<14 then aufdecken(i,j+1);
        if (i<14) and (j>0) then aufdecken(i+1,j-1);
        if i<14 then aufdecken(i+1,j);
        if (i<14) and (j<14) then aufdecken(i+1,j+1);
     end;

  // Niederlage erkennen
  verloren := false;
  for i := 0 to 14 do
    for j := 0 to 14 do
      if (button[i,j].color = clwhite) and (button[i,j].wert = -1) then
      begin
        verloren := true;
        timer1.enabled := false;
        button[i,j].color := clred;
      end;

  if verloren then
  begin
    for i := 0 to 14 do
      for j := 0 to 14 do
      begin
        aufdecken(i,j);
      end;
  end;
end;

end.

