unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  ExtCtrls;
// STDControls wegen TLabel ergänzen

  type

  { TMineButton }

  TMineButton = class(TLabel)
     public
      wert: integer;
      markiert: boolean;
      links, oben, rechts, unten : TMineButton;
      aufgedeckt : boolean;
      constructor create(AOwner: TComponent);  override;
      procedure NachbarnReferenzieren (o, r, u, l: TMineButton);
      procedure setGroessePosition(x, y: integer);
      procedure WertBerechnen;
      procedure Aufdecken;
      procedure MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
  end;


type

  { TForm1 }

  TForm1 = class(TForm)
    procedure FormCreate(Sender: TObject);

  end;



var
  Form1: TForm1;
  minenZahl: integer = 20;
  markieren: boolean;

  a : array[0..16, 0..16] of TMineButton;

implementation

{$R *.lfm}

procedure TMineButton.setGroessePosition(x, y: integer);
begin
   self.Height:=25;
   self.Width:=25;
   //self.Shape:=stcircle;
   self.Left:=x;
   self.Top:=y;
   self.Cursor:= crhandpoint;
end;

procedure TMineButton.WertBerechnen; // alle 9 angrenzenden Felder müssen abgefragt werden
begin
  if self.wert <> -1 then;
      begin
        if self.oben <> nil then
          begin
           if self.oben.wert = -1 then
              self.wert:= self.wert+1;

           if self.oben.links <> nil then
               if self.oben.links.wert = -1 then
                   self.wert := self.wert + 1;

           if self.oben.rechts <> nil then
               if self.oben.rechts.wert = -1 then
                   self.wert := self.wert + 1;
          end;

         if self.links <> nil then
            if self.links.wert = -1 then
                self.wert:=self.wert +1;

         if self.rechts <> nil then
            if self.rechts.wert = -1
             then self.wert:=self.wert +1; ;

         if self.unten <> nil then
          begin
           if self.unten.wert = -1 then
              self.wert:= self.wert+1;

           if self.unten.links <> nil then
               if self.unten.links.wert = -1 then
                   self.wert := self.wert + 1;

           if self.unten.rechts <> nil then
               if self.unten.rechts.wert = -1 then
                   self.wert := self.wert + 1;
          end;
      end;
end;

procedure TMineButton.Aufdecken;
begin
  if self.wert = 0 then
     begin
     self.Color:= clwhite;
     self.aufgedeckt:=true;
     end;

  if self.oben <> nil then
     if (self.oben.wert = 0) and (self.oben.aufgedeckt=false) then
       self.oben.Aufdecken;

  if self.rechts <> nil then
     if (self.rechts.wert = 0)  and (self.rechts.aufgedeckt=false) then
       self.rechts.Aufdecken;

  if self.unten <> nil then
     if (self.unten.wert = 0)  and (self.unten.aufgedeckt=false) then
       self.unten.Aufdecken;

  if self.links <> nil then
     if (self.links.wert = 0)  and (self.oben.aufgedeckt=false) then
       self.links.Aufdecken;
end;


constructor TMineButton.create(AOwner: TComponent);
begin
  inherited create(AOwner);
  self.Font.Style := [fsbold];
  self.Font.Name := 'Tahoma';
  self.AutoSize := false;
  self.Alignment := taCenter;
  self.color := clltgray;
  self.layout := tlcenter;
  //self.height := 16;
  //self.width := 16;
  self.wert := 0;
  self.markiert := false;
  self.aufgedeckt:= false;
end;

procedure TMineButton.NachbarnReferenzieren(o, r, u, l: TMineButton);
begin
    self.links := l;
    self.oben := o;
    self.rechts := r;
    self.unten := u;
end;

procedure TMineButton.MouseDown(Button: TMouseButton; Shift: TShiftState; X,
  Y: Integer);
begin
  if button = mbLeft then
  begin
    if wert > 0 then
      begin
      caption := inttostr(wert);
      color := clwhite
      end
    else if wert = -1 then
      begin
      caption := inttostr(X);
      color := clred;
      end
    else if wert = 0 then
      begin
      //caption := inttostr(X);
      //color := clwhite;
      self.Aufdecken;
      end;
  end;


  if button = mbRight then
  begin
    if color <> clgreen then
      color := clgreen
    else
      color := clltgray;
  end;


end;

procedure TForm1.FormCreate(Sender: TObject);
var i, j: integer;
x, y: integer;
Zeile, Spalte: integer;
begin

    // Damit das Referenzieren leichter geht
    for Zeile := 0 to 16 do
      for Spalte := 0 to 16 do
         begin
         a[Zeile,Spalte] := nil
         end;

    for Zeile := 1 to 15 do
      for Spalte := 1 to 15 do
         begin
         a[Zeile,Spalte] := TMineButton.create(self);
         a[Zeile,Spalte].Parent := Form1;
         a[Zeile,Spalte].setGroessePosition (20 + (Zeile-1)*26, 20 + (Spalte-1)*26);
         end;

    // Fenstergröße
    self.Width:= 26*15 + 20*2;
    self.Height:= 26*15 + 20*2; ;

   for Zeile := 1 to 15 do
      for Spalte := 1 to 15 do
         begin
         // bei 1 und 5 wird auf nil referenziert
         a[Zeile,Spalte].NachbarnReferenzieren(a[Zeile-1, Spalte] , a[Zeile,Spalte+1], a[Zeile+1,Spalte], a[Zeile, Spalte-1]);
         end;

  // Minen legen
  // Minen können zufällig auch doppelt belegt sein (macht hier aber nichts)
  randomize;
  for i:=1 to minenZahl do
  begin
     x := random (14)+1;
     y := random (14)+1;
     a[x,y].wert := -1; // Minen -1
  end;

   for Zeile := 1 to 15 do
      for Spalte := 1 to 15 do
         a[Zeile,Spalte].WertBerechnen;

   //!!!!!!!!!!!!!!!!!!!
   for Zeile := 1 to 15 do
      for Spalte := 1 to 15 do
         a[Zeile,Spalte].caption := IntToStr(a[Zeile,Spalte].wert);

end;



end.

