unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  ExtCtrls;
// STDControls wegen TLabel ergänzen

  type

  { TMineButton }

  TMineButton = class(TLabel)
     public
      wert: integer;
      markiert: boolean;
      links, oben, rechts, unten : TMineButton;
      aufgedeckt : boolean;
      constructor create(AOwner: TComponent);  override;
      procedure NachbarnReferenzieren (o, r, u, l: TMineButton);
      procedure setGroessePosition(x, y: integer);
      procedure WertBerechnen;
      procedure Aufdecken;
      procedure MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
  end;


type

  { TForm1 }

  TForm1 = class(TForm)
    procedure FormCreate(Sender: TObject);
  end;



var
  Form1: TForm1;
  MinenZahl: integer = 15;
  a : array[0..16, 0..16] of TMineButton;

implementation

{$R *.lfm}

procedure TMineButton.setGroessePosition(x, y: integer);
begin
   self.Height:=30;
   self.Width:=30;
   self.Left:=x;
   self.Top:=y;
   self.Cursor:= crhandpoint;
end;

procedure TMineButton.WertBerechnen; // alle 8 angrenzenden Felder müssen abgefragt werden
begin
if self.wert <> -1 then
begin
 if (self.oben <> nil) and (self.oben.wert = -1) then
      self.wert:=self.wert +1;
 if (self.rechts <> nil) and (self.rechts.wert = -1) then
      self.wert:=self.wert +1;
 if (self.unten <> nil) and (self.unten.wert = -1) then
      self.wert:=self.wert +1;
 if (self.links <> nil) and (self.links.wert = -1) then
      self.wert:=self.wert +1;



 if (self.oben <> nil) and (self.oben.links <> nil) and (self.oben.links.wert = -1) then
      self.wert:=self.wert +1;
 if (self.oben <> nil) and (self.oben.rechts <> nil) and (self.oben.rechts.wert = -1) then
      self.wert:=self.wert +1;
 if (self.unten <> nil) and (self.unten.links <> nil) and (self.unten.links.wert = -1) then
      self.wert:=self.wert +1;
 if (self.unten <> nil) and (self.unten.rechts <> nil) and (self.unten.rechts.wert = -1) then
      self.wert:=self.wert +1;
end;

end;

procedure TMineButton.Aufdecken;
begin
if self.wert = 0 then
  begin
     self.Color:= clwhite;
     self.aufgedeckt:=true;


    if self.oben <> nil then
        if (self.oben.wert = 0) and (self.oben.aufgedeckt=false) then
           self.oben.Aufdecken;

     if self.rechts <> nil then
        if (self.rechts.wert = 0)  and (self.rechts.aufgedeckt=false) then
          self.rechts.Aufdecken;

     if self.unten <> nil then
        if (self.unten.wert = 0)  and (self.unten.aufgedeckt=false) then
          self.unten.Aufdecken;

     if self.links <> nil then
        if (self.links.wert = 0)  and (self.links.aufgedeckt=false) then
          self.links.Aufdecken;

  end;
end;


constructor TMineButton.create(AOwner: TComponent);
begin
  inherited create(AOwner);
  self.Font.Style := [fsbold];
  self.Font.Name := 'Tahoma';
  self.AutoSize := false;
  self.Alignment := taCenter;
  self.color := clltgray;
  self.layout := tlcenter;
  self.wert := 0;
  self.markiert := false;
  self.aufgedeckt:= false;
end;

procedure TMineButton.NachbarnReferenzieren(o, r, u, l: TMineButton);
begin
    self.links := l;
    self.oben := o;
    self.rechts := r;
    self.unten := u;
end;

procedure TMineButton.MouseDown(Button: TMouseButton; Shift: TShiftState; X,
  Y: Integer);
begin
  if button = mbLeft then
  begin
    if self.wert > 0 then
      begin
      caption := inttostr(wert);
      color := clwhite
      end
    else if wert = -1 then
      begin
      caption := 'X';
      color := clred;
      end
    else if wert = 0 then
      begin
      self.Aufdecken;
      end;
  end;


  if button = mbRight then
  begin
    if color <> clyellow then
      color := clyellow
    else
      color := clltgray;
  end;


end;

procedure TForm1.FormCreate(Sender: TObject);
var Zeile, Spalte, i, x, y: integer;
begin

    // Damit das Referenzieren leichter geht
    for Zeile := 0 to 16 do
      for Spalte := 0 to 16 do
         begin
         a[Zeile,Spalte] := nil
         end;

    for Zeile := 1 to 15 do
      for Spalte := 1 to 15 do
         begin
         a[Zeile,Spalte] := TMineButton.create(self);
         a[Zeile,Spalte].Parent := Form1;
         a[Zeile,Spalte].setGroessePosition (20 + (Spalte-1)*31, 20 + (Zeile-1)*31);
                                           // Spalten - AUFPASSEN !!!!!    Zeilen - AUFPASSEN!!!!  Größe +1
         end;

    // Fenstergröße
    self.Width:= 31*15 + 20*2;   // (Kästchengröße +1 ) * Anzahl der Kästchen +  2* Rand
    self.Height:= 31*15 + 20*2; ;

   for Zeile := 1 to 15 do
      for Spalte := 1 to 15 do
         begin
         // bei 1 und 5 wird auf nil referenziert   -->>  oben, rechts, unten, linke:
         a[Zeile,Spalte].NachbarnReferenzieren(a[Zeile-1, Spalte] , a[Zeile,Spalte+1], a[Zeile+1,Spalte], a[Zeile, Spalte-1]);
         end;

  // Minen legen
  // Minen können zufällig auch doppelt belegt sein (macht hier aber nichts)
  randomize;

  //x:= 5; y := 1;
  for i:=1 to minenZahl do
  begin
     x :=  random (15)+1;
     y := random (15)+1;
     a[x,y].wert := -1; // Minen -1
  end;

   for Zeile := 1 to 15 do
      for Spalte := 1 to 15 do
         a[Zeile,Spalte].WertBerechnen;

  {//!!!!!!!!!!!!!!!!!!!
   for Zeile := 1 to 15 do
      for Spalte := 1 to 15 do
         a[Zeile,Spalte].caption := IntToStr(a[Zeile,Spalte].wert);   }

end;





end.

